*+
*+
*+    Source Module => D:\SRC\READMEM\GETVARFR.PRG
*+
*+    Functions: Function GETVARFROM()
*+               Function FEOF()
*+               Function MODULUS()
*+
*+    Reformatted by Click! 1.13 on Mar-25-1998 at 11:42 pm
*+
*+

*+
*+
*+    Function GETVARFROM()
*+
*+    Called from ( readmem.prg  )   1 - procedure readmem()
*+
*+
*+
function GETVARFROM( cMemFile )

local xVarValue    := NIL
local nHandle
local nFilePoint
local cMemBuff
local cVarName
local cID
local nSize
local nLen
local cBuffer
local cData
local nHi
local nLo
local lFlag
local nB1
local nB2
local nB3
local nB4
local nTotal
local nOutput
local nValue
local aMemVar
local aMemVarArray := {}

if valtype( cMemFile ) = "C" .and. file( cMemFile )

   nHandle    := fopen( cMemFile )
   nFilePoint := fseek( nHandle, 0, 2 )
   fseek( nHandle, 0 )

   if nFilePoint > 1

      xVarValue := ""

      do while fseek( nHandle, 0, 1 ) + 1 < nFilePoint .and. !FEOF( nHandle )

         cMemBuff := space( 18 )
         fread( nHandle, @cMemBuff, 18 )
         cVarName := left( cMemBuff, at( chr( 0 ), cMemBuff ) - 1 )
         cID      := substr( cMemBuff, 12, 1 )
         nSize    := bin2w( right( cMemBuff, 2 ) )
         nLen     := if( cID $ "", 14 + nSize, 22 )
         cBuffer  := space( nLen )
         fread( nHandle, @cBuffer, nLen )
         cData := substr( cBuffer, 15 )

         if cID == chr( 195 )            // character

            aMemVar   := { cVarName, "C", cData }
            xVarValue := cData

         elseif cID == chr( 204 )        // logic

            aMemVar   := { cVarName, "L", asc( cData ) == 1 }
            xVarValue := asc( cData ) == 1

         elseif cID == chr( 206 )        // Numeric

            cBuffer   := substr( cBuffer, 15 )
            nHi       := MODULUS( asc( substr( cBuffer, 8, 1 ) ), 128 ) * 16
            nLo       := int( asc( substr( cBuffer, 7, 1 ) ) / 16 )
            nValue    := nHi + nLo - 1023
            lFlag     := int( asc( substr( cBuffer, 8, 1 ) ) / 16 ) >= 8
            nB1       := MODULUS( asc( substr( cBuffer, 7, 1 ) ), 16 ) / 16
            nB2       := bin2w( substr( cBuffer, 5, 2 ) ) / ( 65536 * 16 )
            nB3       := bin2w( substr( cBuffer, 3, 2 ) ) / ( 65536 * 65536 * 16 )
            nB4       := bin2w( substr( cBuffer, 1, 2 ) ) / ( 65536 * 65536 * 65536 * 16 )
            nTotal    := nB1 + nB2 + nB3 + nB4
            nOutput   := if( lFlag, - ( 1 + nTotal ) * 2 ^ nValue, ( 1 + nTotal ) * 2 ^ nValue )
            xVarValue := val( transform( nOutput, "@B" ) )

            aMemVar := { cVarName, "N", xVarValue }

         elseif cID == chr( 196 )        // Date

            cBuffer   := substr( cBuffer, 15 )
            nHi       := MODULUS( asc( substr( cBuffer, 8, 1 ) ), 128 ) * 16
            nLo       := int( asc( substr( cBuffer, 7, 1 ) ) / 16 )
            nValue    := nHi + nLo - 1023
            lFlag     := int( asc( substr( cBuffer, 8, 1 ) ) / 16 ) >= 8
            nB1       := MODULUS( asc( substr( cBuffer, 7, 1 ) ), 16 ) / 16
            nB2       := bin2w( substr( cBuffer, 5, 2 ) ) / ( 65536 * 16 )
            nB3       := bin2w( substr( cBuffer, 3, 2 ) ) / ( 65536 * 65536 * 16 )
            nB4       := bin2w( substr( cBuffer, 1, 2 ) ) / ( 65536 * 65536 * 65536 * 16 )
            nTotal    := nB1 + nB2 + nB3 + nB4
            nOutput   := if( lFlag, - ( 1 + nTotal ) * 2 ^ nValue, ( 1 + nTotal ) * 2 ^ nValue )
            xVarValue := dtoc( ctod( "01/01/0100" ) + nOutput - 1757585 )

            aMemVar := { cVarName, "D", xVarValue }

         endif

         aadd( aMemVarArray, aMemVar )

      enddo

   endif

   fclose( nHandle )

endif

return aMemVarArray

*+
*+
*+    Function FEOF()
*+
*+    Called from ( getvarfr.prg )   1 - function getvarfrom()
*+
*+
*+
function FEOF( nHandle )

local nCurrPos
local nFileSize

nCurrPos  := fseek( nHandle, 0, 1 )
nFileSize := fseek( nHandle, 0, 2 )
fseek( nHandle, nCurrPos, 0 )

return nFileSize < nCurrPos

*+
*+
*+    Function MODULUS()
*+
*+    Called from ( getvarfr.prg )   4 - function getvarfrom()
*+
*+
*+
function MODULUS( nParm1, nParm2 )

local x
local nRetVal := 0

if valtype( nParm1 ) = "N" .and. valtype( nParm2 ) = "N"
   if nParm2 = 0
      nRetVal := nParm1
   else
      x       := nParm1 % nParm2
      nRetVal := if( x * nParm2 < 0, x + nParm2, x )
   endif
endif

return nRetVal

*+ EOF: GETVARFR.PRG
